#ifndef _2048_H_
#define _2048_H_

#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include <string.h>

#define EMPTY   0
#define LEFT    1
#define RIGHT   2
#define UP      3
#define DOWN    4
#define LOST    7
#define WON     8
#define NEITHER 9

#define SIZE    4

void initialize(void);
void new_block(void);

void move_left(uint8_t, uint8_t[SIZE]);
void reflect(uint8_t[SIZE][SIZE]);
void rotate(uint8_t[SIZE][SIZE], uint8_t);
void move(uint8_t, uint8_t[SIZE][SIZE]);
uint8_t test(uint8_t, uint8_t[SIZE][SIZE]);

void inc(void);

uint8_t evaluate(void);
uint8_t get_value(uint8_t, uint8_t);

#endif
